	component niosiiSystem is
		port (
			clk_clk           : in    std_logic                     := 'X';             -- clk
			green_leds_export : out   std_logic_vector(7 downto 0);                     -- export
			key_1_export      : in    std_logic                     := 'X';             -- export
			key_2_export      : in    std_logic                     := 'X';             -- export
			key_3_export      : in    std_logic                     := 'X';             -- export
			red_leds_export   : out   std_logic_vector(17 downto 0);                    -- export
			reset_reset_n     : in    std_logic                     := 'X';             -- reset_n
			sram_DQ           : inout std_logic_vector(15 downto 0) := (others => 'X'); -- DQ
			sram_ADDR         : out   std_logic_vector(19 downto 0);                    -- ADDR
			sram_LB_N         : out   std_logic;                                        -- LB_N
			sram_UB_N         : out   std_logic;                                        -- UB_N
			sram_CE_N         : out   std_logic;                                        -- CE_N
			sram_OE_N         : out   std_logic;                                        -- OE_N
			sram_WE_N         : out   std_logic;                                        -- WE_N
			switches_export   : in    std_logic_vector(17 downto 0) := (others => 'X'); -- export
			sdram_addr        : out   std_logic_vector(12 downto 0);                    -- addr
			sdram_ba          : out   std_logic_vector(1 downto 0);                     -- ba
			sdram_cas_n       : out   std_logic;                                        -- cas_n
			sdram_cke         : out   std_logic;                                        -- cke
			sdram_cs_n        : out   std_logic;                                        -- cs_n
			sdram_dq          : inout std_logic_vector(31 downto 0) := (others => 'X'); -- dq
			sdram_dqm         : out   std_logic_vector(3 downto 0);                     -- dqm
			sdram_ras_n       : out   std_logic;                                        -- ras_n
			sdram_we_n        : out   std_logic                                         -- we_n
		);
	end component niosiiSystem;

	u0 : component niosiiSystem
		port map (
			clk_clk           => CONNECTED_TO_clk_clk,           --        clk.clk
			green_leds_export => CONNECTED_TO_green_leds_export, -- green_leds.export
			key_1_export      => CONNECTED_TO_key_1_export,      --      key_1.export
			key_2_export      => CONNECTED_TO_key_2_export,      --      key_2.export
			key_3_export      => CONNECTED_TO_key_3_export,      --      key_3.export
			red_leds_export   => CONNECTED_TO_red_leds_export,   --   red_leds.export
			reset_reset_n     => CONNECTED_TO_reset_reset_n,     --      reset.reset_n
			sram_DQ           => CONNECTED_TO_sram_DQ,           --       sram.DQ
			sram_ADDR         => CONNECTED_TO_sram_ADDR,         --           .ADDR
			sram_LB_N         => CONNECTED_TO_sram_LB_N,         --           .LB_N
			sram_UB_N         => CONNECTED_TO_sram_UB_N,         --           .UB_N
			sram_CE_N         => CONNECTED_TO_sram_CE_N,         --           .CE_N
			sram_OE_N         => CONNECTED_TO_sram_OE_N,         --           .OE_N
			sram_WE_N         => CONNECTED_TO_sram_WE_N,         --           .WE_N
			switches_export   => CONNECTED_TO_switches_export,   --   switches.export
			sdram_addr        => CONNECTED_TO_sdram_addr,        --      sdram.addr
			sdram_ba          => CONNECTED_TO_sdram_ba,          --           .ba
			sdram_cas_n       => CONNECTED_TO_sdram_cas_n,       --           .cas_n
			sdram_cke         => CONNECTED_TO_sdram_cke,         --           .cke
			sdram_cs_n        => CONNECTED_TO_sdram_cs_n,        --           .cs_n
			sdram_dq          => CONNECTED_TO_sdram_dq,          --           .dq
			sdram_dqm         => CONNECTED_TO_sdram_dqm,         --           .dqm
			sdram_ras_n       => CONNECTED_TO_sdram_ras_n,       --           .ras_n
			sdram_we_n        => CONNECTED_TO_sdram_we_n         --           .we_n
		);

