// niosiiSystem.v

// Generated using ACDS version 15.0 145

`timescale 1 ps / 1 ps
module niosiiSystem (
		input  wire        clk_clk,           //        clk.clk
		output wire [7:0]  green_leds_export, // green_leds.export
		input  wire        key_1_export,      //      key_1.export
		input  wire        key_2_export,      //      key_2.export
		input  wire        key_3_export,      //      key_3.export
		output wire [17:0] red_leds_export,   //   red_leds.export
		input  wire        reset_reset_n,     //      reset.reset_n
		output wire [12:0] sdram_addr,        //      sdram.addr
		output wire [1:0]  sdram_ba,          //           .ba
		output wire        sdram_cas_n,       //           .cas_n
		output wire        sdram_cke,         //           .cke
		output wire        sdram_cs_n,        //           .cs_n
		inout  wire [31:0] sdram_dq,          //           .dq
		output wire [3:0]  sdram_dqm,         //           .dqm
		output wire        sdram_ras_n,       //           .ras_n
		output wire        sdram_we_n,        //           .we_n
		inout  wire [15:0] sram_DQ,           //       sram.DQ
		output wire [19:0] sram_ADDR,         //           .ADDR
		output wire        sram_LB_N,         //           .LB_N
		output wire        sram_UB_N,         //           .UB_N
		output wire        sram_CE_N,         //           .CE_N
		output wire        sram_OE_N,         //           .OE_N
		output wire        sram_WE_N,         //           .WE_N
		input  wire [17:0] switches_export    //   switches.export
	);

	wire  [31:0] nios_processor_data_master_readdata;                          // mm_interconnect_0:nios_processor_data_master_readdata -> nios_processor:d_readdata
	wire         nios_processor_data_master_waitrequest;                       // mm_interconnect_0:nios_processor_data_master_waitrequest -> nios_processor:d_waitrequest
	wire         nios_processor_data_master_debugaccess;                       // nios_processor:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:nios_processor_data_master_debugaccess
	wire  [27:0] nios_processor_data_master_address;                           // nios_processor:d_address -> mm_interconnect_0:nios_processor_data_master_address
	wire   [3:0] nios_processor_data_master_byteenable;                        // nios_processor:d_byteenable -> mm_interconnect_0:nios_processor_data_master_byteenable
	wire         nios_processor_data_master_read;                              // nios_processor:d_read -> mm_interconnect_0:nios_processor_data_master_read
	wire         nios_processor_data_master_readdatavalid;                     // mm_interconnect_0:nios_processor_data_master_readdatavalid -> nios_processor:d_readdatavalid
	wire         nios_processor_data_master_write;                             // nios_processor:d_write -> mm_interconnect_0:nios_processor_data_master_write
	wire  [31:0] nios_processor_data_master_writedata;                         // nios_processor:d_writedata -> mm_interconnect_0:nios_processor_data_master_writedata
	wire  [31:0] nios_processor_instruction_master_readdata;                   // mm_interconnect_0:nios_processor_instruction_master_readdata -> nios_processor:i_readdata
	wire         nios_processor_instruction_master_waitrequest;                // mm_interconnect_0:nios_processor_instruction_master_waitrequest -> nios_processor:i_waitrequest
	wire  [27:0] nios_processor_instruction_master_address;                    // nios_processor:i_address -> mm_interconnect_0:nios_processor_instruction_master_address
	wire         nios_processor_instruction_master_read;                       // nios_processor:i_read -> mm_interconnect_0:nios_processor_instruction_master_read
	wire         nios_processor_instruction_master_readdatavalid;              // mm_interconnect_0:nios_processor_instruction_master_readdatavalid -> nios_processor:i_readdatavalid
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;     // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;       // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest;    // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;           // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;          // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;      // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire  [15:0] mm_interconnect_0_sram_avalon_sram_slave_readdata;            // sram:readdata -> mm_interconnect_0:sram_avalon_sram_slave_readdata
	wire  [19:0] mm_interconnect_0_sram_avalon_sram_slave_address;             // mm_interconnect_0:sram_avalon_sram_slave_address -> sram:address
	wire         mm_interconnect_0_sram_avalon_sram_slave_read;                // mm_interconnect_0:sram_avalon_sram_slave_read -> sram:read
	wire   [1:0] mm_interconnect_0_sram_avalon_sram_slave_byteenable;          // mm_interconnect_0:sram_avalon_sram_slave_byteenable -> sram:byteenable
	wire         mm_interconnect_0_sram_avalon_sram_slave_readdatavalid;       // sram:readdatavalid -> mm_interconnect_0:sram_avalon_sram_slave_readdatavalid
	wire         mm_interconnect_0_sram_avalon_sram_slave_write;               // mm_interconnect_0:sram_avalon_sram_slave_write -> sram:write
	wire  [15:0] mm_interconnect_0_sram_avalon_sram_slave_writedata;           // mm_interconnect_0:sram_avalon_sram_slave_writedata -> sram:writedata
	wire  [31:0] mm_interconnect_0_sysid_control_slave_readdata;               // sysid:readdata -> mm_interconnect_0:sysid_control_slave_readdata
	wire   [0:0] mm_interconnect_0_sysid_control_slave_address;                // mm_interconnect_0:sysid_control_slave_address -> sysid:address
	wire  [31:0] mm_interconnect_0_nios_processor_debug_mem_slave_readdata;    // nios_processor:debug_mem_slave_readdata -> mm_interconnect_0:nios_processor_debug_mem_slave_readdata
	wire         mm_interconnect_0_nios_processor_debug_mem_slave_waitrequest; // nios_processor:debug_mem_slave_waitrequest -> mm_interconnect_0:nios_processor_debug_mem_slave_waitrequest
	wire         mm_interconnect_0_nios_processor_debug_mem_slave_debugaccess; // mm_interconnect_0:nios_processor_debug_mem_slave_debugaccess -> nios_processor:debug_mem_slave_debugaccess
	wire   [8:0] mm_interconnect_0_nios_processor_debug_mem_slave_address;     // mm_interconnect_0:nios_processor_debug_mem_slave_address -> nios_processor:debug_mem_slave_address
	wire         mm_interconnect_0_nios_processor_debug_mem_slave_read;        // mm_interconnect_0:nios_processor_debug_mem_slave_read -> nios_processor:debug_mem_slave_read
	wire   [3:0] mm_interconnect_0_nios_processor_debug_mem_slave_byteenable;  // mm_interconnect_0:nios_processor_debug_mem_slave_byteenable -> nios_processor:debug_mem_slave_byteenable
	wire         mm_interconnect_0_nios_processor_debug_mem_slave_write;       // mm_interconnect_0:nios_processor_debug_mem_slave_write -> nios_processor:debug_mem_slave_write
	wire  [31:0] mm_interconnect_0_nios_processor_debug_mem_slave_writedata;   // mm_interconnect_0:nios_processor_debug_mem_slave_writedata -> nios_processor:debug_mem_slave_writedata
	wire         mm_interconnect_0_onchip_memory_s1_chipselect;                // mm_interconnect_0:onchip_memory_s1_chipselect -> onchip_memory:chipselect
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_readdata;                  // onchip_memory:readdata -> mm_interconnect_0:onchip_memory_s1_readdata
	wire  [12:0] mm_interconnect_0_onchip_memory_s1_address;                   // mm_interconnect_0:onchip_memory_s1_address -> onchip_memory:address
	wire   [3:0] mm_interconnect_0_onchip_memory_s1_byteenable;                // mm_interconnect_0:onchip_memory_s1_byteenable -> onchip_memory:byteenable
	wire         mm_interconnect_0_onchip_memory_s1_write;                     // mm_interconnect_0:onchip_memory_s1_write -> onchip_memory:write
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_writedata;                 // mm_interconnect_0:onchip_memory_s1_writedata -> onchip_memory:writedata
	wire         mm_interconnect_0_onchip_memory_s1_clken;                     // mm_interconnect_0:onchip_memory_s1_clken -> onchip_memory:clken
	wire         mm_interconnect_0_green_leds_s1_chipselect;                   // mm_interconnect_0:green_leds_s1_chipselect -> green_leds:chipselect
	wire  [31:0] mm_interconnect_0_green_leds_s1_readdata;                     // green_leds:readdata -> mm_interconnect_0:green_leds_s1_readdata
	wire   [1:0] mm_interconnect_0_green_leds_s1_address;                      // mm_interconnect_0:green_leds_s1_address -> green_leds:address
	wire         mm_interconnect_0_green_leds_s1_write;                        // mm_interconnect_0:green_leds_s1_write -> green_leds:write_n
	wire  [31:0] mm_interconnect_0_green_leds_s1_writedata;                    // mm_interconnect_0:green_leds_s1_writedata -> green_leds:writedata
	wire         mm_interconnect_0_sys_clk_timer_s1_chipselect;                // mm_interconnect_0:sys_clk_timer_s1_chipselect -> sys_clk_timer:chipselect
	wire  [15:0] mm_interconnect_0_sys_clk_timer_s1_readdata;                  // sys_clk_timer:readdata -> mm_interconnect_0:sys_clk_timer_s1_readdata
	wire   [2:0] mm_interconnect_0_sys_clk_timer_s1_address;                   // mm_interconnect_0:sys_clk_timer_s1_address -> sys_clk_timer:address
	wire         mm_interconnect_0_sys_clk_timer_s1_write;                     // mm_interconnect_0:sys_clk_timer_s1_write -> sys_clk_timer:write_n
	wire  [15:0] mm_interconnect_0_sys_clk_timer_s1_writedata;                 // mm_interconnect_0:sys_clk_timer_s1_writedata -> sys_clk_timer:writedata
	wire         mm_interconnect_0_red_leds_s1_chipselect;                     // mm_interconnect_0:red_leds_s1_chipselect -> red_leds:chipselect
	wire  [31:0] mm_interconnect_0_red_leds_s1_readdata;                       // red_leds:readdata -> mm_interconnect_0:red_leds_s1_readdata
	wire   [1:0] mm_interconnect_0_red_leds_s1_address;                        // mm_interconnect_0:red_leds_s1_address -> red_leds:address
	wire         mm_interconnect_0_red_leds_s1_write;                          // mm_interconnect_0:red_leds_s1_write -> red_leds:write_n
	wire  [31:0] mm_interconnect_0_red_leds_s1_writedata;                      // mm_interconnect_0:red_leds_s1_writedata -> red_leds:writedata
	wire  [31:0] mm_interconnect_0_switches_s1_readdata;                       // switches:readdata -> mm_interconnect_0:switches_s1_readdata
	wire   [1:0] mm_interconnect_0_switches_s1_address;                        // mm_interconnect_0:switches_s1_address -> switches:address
	wire         mm_interconnect_0_key_3_s1_chipselect;                        // mm_interconnect_0:key_3_s1_chipselect -> key_3:chipselect
	wire  [31:0] mm_interconnect_0_key_3_s1_readdata;                          // key_3:readdata -> mm_interconnect_0:key_3_s1_readdata
	wire   [1:0] mm_interconnect_0_key_3_s1_address;                           // mm_interconnect_0:key_3_s1_address -> key_3:address
	wire         mm_interconnect_0_key_3_s1_write;                             // mm_interconnect_0:key_3_s1_write -> key_3:write_n
	wire  [31:0] mm_interconnect_0_key_3_s1_writedata;                         // mm_interconnect_0:key_3_s1_writedata -> key_3:writedata
	wire         mm_interconnect_0_key_2_s1_chipselect;                        // mm_interconnect_0:key_2_s1_chipselect -> key_2:chipselect
	wire  [31:0] mm_interconnect_0_key_2_s1_readdata;                          // key_2:readdata -> mm_interconnect_0:key_2_s1_readdata
	wire   [1:0] mm_interconnect_0_key_2_s1_address;                           // mm_interconnect_0:key_2_s1_address -> key_2:address
	wire         mm_interconnect_0_key_2_s1_write;                             // mm_interconnect_0:key_2_s1_write -> key_2:write_n
	wire  [31:0] mm_interconnect_0_key_2_s1_writedata;                         // mm_interconnect_0:key_2_s1_writedata -> key_2:writedata
	wire         mm_interconnect_0_key_1_s1_chipselect;                        // mm_interconnect_0:key_1_s1_chipselect -> key_1:chipselect
	wire  [31:0] mm_interconnect_0_key_1_s1_readdata;                          // key_1:readdata -> mm_interconnect_0:key_1_s1_readdata
	wire   [1:0] mm_interconnect_0_key_1_s1_address;                           // mm_interconnect_0:key_1_s1_address -> key_1:address
	wire         mm_interconnect_0_key_1_s1_write;                             // mm_interconnect_0:key_1_s1_write -> key_1:write_n
	wire  [31:0] mm_interconnect_0_key_1_s1_writedata;                         // mm_interconnect_0:key_1_s1_writedata -> key_1:writedata
	wire         mm_interconnect_0_sdram_s1_chipselect;                        // mm_interconnect_0:sdram_s1_chipselect -> sdram:az_cs
	wire  [31:0] mm_interconnect_0_sdram_s1_readdata;                          // sdram:za_data -> mm_interconnect_0:sdram_s1_readdata
	wire         mm_interconnect_0_sdram_s1_waitrequest;                       // sdram:za_waitrequest -> mm_interconnect_0:sdram_s1_waitrequest
	wire  [24:0] mm_interconnect_0_sdram_s1_address;                           // mm_interconnect_0:sdram_s1_address -> sdram:az_addr
	wire         mm_interconnect_0_sdram_s1_read;                              // mm_interconnect_0:sdram_s1_read -> sdram:az_rd_n
	wire   [3:0] mm_interconnect_0_sdram_s1_byteenable;                        // mm_interconnect_0:sdram_s1_byteenable -> sdram:az_be_n
	wire         mm_interconnect_0_sdram_s1_readdatavalid;                     // sdram:za_valid -> mm_interconnect_0:sdram_s1_readdatavalid
	wire         mm_interconnect_0_sdram_s1_write;                             // mm_interconnect_0:sdram_s1_write -> sdram:az_wr_n
	wire  [31:0] mm_interconnect_0_sdram_s1_writedata;                         // mm_interconnect_0:sdram_s1_writedata -> sdram:az_data
	wire         irq_mapper_receiver0_irq;                                     // jtag_uart:av_irq -> irq_mapper:receiver0_irq
	wire         irq_mapper_receiver1_irq;                                     // sys_clk_timer:irq -> irq_mapper:receiver1_irq
	wire         irq_mapper_receiver2_irq;                                     // key_3:irq -> irq_mapper:receiver2_irq
	wire         irq_mapper_receiver3_irq;                                     // key_2:irq -> irq_mapper:receiver3_irq
	wire         irq_mapper_receiver4_irq;                                     // key_1:irq -> irq_mapper:receiver4_irq
	wire  [31:0] nios_processor_irq_irq;                                       // irq_mapper:sender_irq -> nios_processor:irq
	wire         rst_controller_reset_out_reset;                               // rst_controller:reset_out -> [green_leds:reset_n, irq_mapper:reset, jtag_uart:rst_n, key_1:reset_n, key_2:reset_n, key_3:reset_n, mm_interconnect_0:nios_processor_reset_reset_bridge_in_reset_reset, nios_processor:reset_n, onchip_memory:reset, red_leds:reset_n, rst_translator:in_reset, sdram:reset_n, sram:reset, switches:reset_n, sys_clk_timer:reset_n, sysid:reset_n]
	wire         rst_controller_reset_out_reset_req;                           // rst_controller:reset_req -> [nios_processor:reset_req, onchip_memory:reset_req, rst_translator:reset_req_in]
	wire         nios_processor_debug_reset_request_reset;                     // nios_processor:debug_reset_request -> rst_controller:reset_in1

	niosiiSystem_green_leds green_leds (
		.clk        (clk_clk),                                    //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),            //               reset.reset_n
		.address    (mm_interconnect_0_green_leds_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_green_leds_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_green_leds_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_green_leds_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_green_leds_s1_readdata),   //                    .readdata
		.out_port   (green_leds_export)                           // external_connection.export
	);

	niosiiSystem_jtag_uart jtag_uart (
		.clk            (clk_clk),                                                   //               clk.clk
		.rst_n          (~rst_controller_reset_out_reset),                           //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver0_irq)                                   //               irq.irq
	);

	niosiiSystem_key_1 key_1 (
		.clk        (clk_clk),                               //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),       //               reset.reset_n
		.address    (mm_interconnect_0_key_1_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_key_1_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_key_1_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_key_1_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_key_1_s1_readdata),   //                    .readdata
		.in_port    (key_1_export),                          // external_connection.export
		.irq        (irq_mapper_receiver4_irq)               //                 irq.irq
	);

	niosiiSystem_key_1 key_2 (
		.clk        (clk_clk),                               //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),       //               reset.reset_n
		.address    (mm_interconnect_0_key_2_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_key_2_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_key_2_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_key_2_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_key_2_s1_readdata),   //                    .readdata
		.in_port    (key_2_export),                          // external_connection.export
		.irq        (irq_mapper_receiver3_irq)               //                 irq.irq
	);

	niosiiSystem_key_1 key_3 (
		.clk        (clk_clk),                               //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),       //               reset.reset_n
		.address    (mm_interconnect_0_key_3_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_key_3_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_key_3_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_key_3_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_key_3_s1_readdata),   //                    .readdata
		.in_port    (key_3_export),                          // external_connection.export
		.irq        (irq_mapper_receiver2_irq)               //                 irq.irq
	);

	niosiiSystem_nios_processor nios_processor (
		.clk                                 (clk_clk),                                                      //                       clk.clk
		.reset_n                             (~rst_controller_reset_out_reset),                              //                     reset.reset_n
		.reset_req                           (rst_controller_reset_out_reset_req),                           //                          .reset_req
		.d_address                           (nios_processor_data_master_address),                           //               data_master.address
		.d_byteenable                        (nios_processor_data_master_byteenable),                        //                          .byteenable
		.d_read                              (nios_processor_data_master_read),                              //                          .read
		.d_readdata                          (nios_processor_data_master_readdata),                          //                          .readdata
		.d_waitrequest                       (nios_processor_data_master_waitrequest),                       //                          .waitrequest
		.d_write                             (nios_processor_data_master_write),                             //                          .write
		.d_writedata                         (nios_processor_data_master_writedata),                         //                          .writedata
		.d_readdatavalid                     (nios_processor_data_master_readdatavalid),                     //                          .readdatavalid
		.debug_mem_slave_debugaccess_to_roms (nios_processor_data_master_debugaccess),                       //                          .debugaccess
		.i_address                           (nios_processor_instruction_master_address),                    //        instruction_master.address
		.i_read                              (nios_processor_instruction_master_read),                       //                          .read
		.i_readdata                          (nios_processor_instruction_master_readdata),                   //                          .readdata
		.i_waitrequest                       (nios_processor_instruction_master_waitrequest),                //                          .waitrequest
		.i_readdatavalid                     (nios_processor_instruction_master_readdatavalid),              //                          .readdatavalid
		.irq                                 (nios_processor_irq_irq),                                       //                       irq.irq
		.debug_reset_request                 (nios_processor_debug_reset_request_reset),                     //       debug_reset_request.reset
		.debug_mem_slave_address             (mm_interconnect_0_nios_processor_debug_mem_slave_address),     //           debug_mem_slave.address
		.debug_mem_slave_byteenable          (mm_interconnect_0_nios_processor_debug_mem_slave_byteenable),  //                          .byteenable
		.debug_mem_slave_debugaccess         (mm_interconnect_0_nios_processor_debug_mem_slave_debugaccess), //                          .debugaccess
		.debug_mem_slave_read                (mm_interconnect_0_nios_processor_debug_mem_slave_read),        //                          .read
		.debug_mem_slave_readdata            (mm_interconnect_0_nios_processor_debug_mem_slave_readdata),    //                          .readdata
		.debug_mem_slave_waitrequest         (mm_interconnect_0_nios_processor_debug_mem_slave_waitrequest), //                          .waitrequest
		.debug_mem_slave_write               (mm_interconnect_0_nios_processor_debug_mem_slave_write),       //                          .write
		.debug_mem_slave_writedata           (mm_interconnect_0_nios_processor_debug_mem_slave_writedata),   //                          .writedata
		.dummy_ci_port                       ()                                                              // custom_instruction_master.readra
	);

	niosiiSystem_onchip_memory onchip_memory (
		.clk        (clk_clk),                                       //   clk1.clk
		.address    (mm_interconnect_0_onchip_memory_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_onchip_memory_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_onchip_memory_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_onchip_memory_s1_write),      //       .write
		.readdata   (mm_interconnect_0_onchip_memory_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_onchip_memory_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_onchip_memory_s1_byteenable), //       .byteenable
		.reset      (rst_controller_reset_out_reset),                // reset1.reset
		.reset_req  (rst_controller_reset_out_reset_req)             //       .reset_req
	);

	niosiiSystem_red_leds red_leds (
		.clk        (clk_clk),                                  //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),          //               reset.reset_n
		.address    (mm_interconnect_0_red_leds_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_red_leds_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_red_leds_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_red_leds_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_red_leds_s1_readdata),   //                    .readdata
		.out_port   (red_leds_export)                           // external_connection.export
	);

	niosiiSystem_sdram sdram (
		.clk            (clk_clk),                                  //   clk.clk
		.reset_n        (~rst_controller_reset_out_reset),          // reset.reset_n
		.az_addr        (mm_interconnect_0_sdram_s1_address),       //    s1.address
		.az_be_n        (~mm_interconnect_0_sdram_s1_byteenable),   //      .byteenable_n
		.az_cs          (mm_interconnect_0_sdram_s1_chipselect),    //      .chipselect
		.az_data        (mm_interconnect_0_sdram_s1_writedata),     //      .writedata
		.az_rd_n        (~mm_interconnect_0_sdram_s1_read),         //      .read_n
		.az_wr_n        (~mm_interconnect_0_sdram_s1_write),        //      .write_n
		.za_data        (mm_interconnect_0_sdram_s1_readdata),      //      .readdata
		.za_valid       (mm_interconnect_0_sdram_s1_readdatavalid), //      .readdatavalid
		.za_waitrequest (mm_interconnect_0_sdram_s1_waitrequest),   //      .waitrequest
		.zs_addr        (sdram_addr),                               //  wire.export
		.zs_ba          (sdram_ba),                                 //      .export
		.zs_cas_n       (sdram_cas_n),                              //      .export
		.zs_cke         (sdram_cke),                                //      .export
		.zs_cs_n        (sdram_cs_n),                               //      .export
		.zs_dq          (sdram_dq),                                 //      .export
		.zs_dqm         (sdram_dqm),                                //      .export
		.zs_ras_n       (sdram_ras_n),                              //      .export
		.zs_we_n        (sdram_we_n)                                //      .export
	);

	niosiiSystem_sram sram (
		.clk           (clk_clk),                                                //                clk.clk
		.reset         (rst_controller_reset_out_reset),                         //              reset.reset
		.SRAM_DQ       (sram_DQ),                                                // external_interface.export
		.SRAM_ADDR     (sram_ADDR),                                              //                   .export
		.SRAM_LB_N     (sram_LB_N),                                              //                   .export
		.SRAM_UB_N     (sram_UB_N),                                              //                   .export
		.SRAM_CE_N     (sram_CE_N),                                              //                   .export
		.SRAM_OE_N     (sram_OE_N),                                              //                   .export
		.SRAM_WE_N     (sram_WE_N),                                              //                   .export
		.address       (mm_interconnect_0_sram_avalon_sram_slave_address),       //  avalon_sram_slave.address
		.byteenable    (mm_interconnect_0_sram_avalon_sram_slave_byteenable),    //                   .byteenable
		.read          (mm_interconnect_0_sram_avalon_sram_slave_read),          //                   .read
		.write         (mm_interconnect_0_sram_avalon_sram_slave_write),         //                   .write
		.writedata     (mm_interconnect_0_sram_avalon_sram_slave_writedata),     //                   .writedata
		.readdata      (mm_interconnect_0_sram_avalon_sram_slave_readdata),      //                   .readdata
		.readdatavalid (mm_interconnect_0_sram_avalon_sram_slave_readdatavalid)  //                   .readdatavalid
	);

	niosiiSystem_switches switches (
		.clk      (clk_clk),                                //                 clk.clk
		.reset_n  (~rst_controller_reset_out_reset),        //               reset.reset_n
		.address  (mm_interconnect_0_switches_s1_address),  //                  s1.address
		.readdata (mm_interconnect_0_switches_s1_readdata), //                    .readdata
		.in_port  (switches_export)                         // external_connection.export
	);

	niosiiSystem_sys_clk_timer sys_clk_timer (
		.clk        (clk_clk),                                       //   clk.clk
		.reset_n    (~rst_controller_reset_out_reset),               // reset.reset_n
		.address    (mm_interconnect_0_sys_clk_timer_s1_address),    //    s1.address
		.writedata  (mm_interconnect_0_sys_clk_timer_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_0_sys_clk_timer_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_0_sys_clk_timer_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_0_sys_clk_timer_s1_write),     //      .write_n
		.irq        (irq_mapper_receiver1_irq)                       //   irq.irq
	);

	niosiiSystem_sysid sysid (
		.clock    (clk_clk),                                        //           clk.clk
		.reset_n  (~rst_controller_reset_out_reset),                //         reset.reset_n
		.readdata (mm_interconnect_0_sysid_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_0_sysid_control_slave_address)   //              .address
	);

	niosiiSystem_mm_interconnect_0 mm_interconnect_0 (
		.Clock_clk_clk                                    (clk_clk),                                                      //                                  Clock_clk.clk
		.nios_processor_reset_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                               // nios_processor_reset_reset_bridge_in_reset.reset
		.nios_processor_data_master_address               (nios_processor_data_master_address),                           //                 nios_processor_data_master.address
		.nios_processor_data_master_waitrequest           (nios_processor_data_master_waitrequest),                       //                                           .waitrequest
		.nios_processor_data_master_byteenable            (nios_processor_data_master_byteenable),                        //                                           .byteenable
		.nios_processor_data_master_read                  (nios_processor_data_master_read),                              //                                           .read
		.nios_processor_data_master_readdata              (nios_processor_data_master_readdata),                          //                                           .readdata
		.nios_processor_data_master_readdatavalid         (nios_processor_data_master_readdatavalid),                     //                                           .readdatavalid
		.nios_processor_data_master_write                 (nios_processor_data_master_write),                             //                                           .write
		.nios_processor_data_master_writedata             (nios_processor_data_master_writedata),                         //                                           .writedata
		.nios_processor_data_master_debugaccess           (nios_processor_data_master_debugaccess),                       //                                           .debugaccess
		.nios_processor_instruction_master_address        (nios_processor_instruction_master_address),                    //          nios_processor_instruction_master.address
		.nios_processor_instruction_master_waitrequest    (nios_processor_instruction_master_waitrequest),                //                                           .waitrequest
		.nios_processor_instruction_master_read           (nios_processor_instruction_master_read),                       //                                           .read
		.nios_processor_instruction_master_readdata       (nios_processor_instruction_master_readdata),                   //                                           .readdata
		.nios_processor_instruction_master_readdatavalid  (nios_processor_instruction_master_readdatavalid),              //                                           .readdatavalid
		.green_leds_s1_address                            (mm_interconnect_0_green_leds_s1_address),                      //                              green_leds_s1.address
		.green_leds_s1_write                              (mm_interconnect_0_green_leds_s1_write),                        //                                           .write
		.green_leds_s1_readdata                           (mm_interconnect_0_green_leds_s1_readdata),                     //                                           .readdata
		.green_leds_s1_writedata                          (mm_interconnect_0_green_leds_s1_writedata),                    //                                           .writedata
		.green_leds_s1_chipselect                         (mm_interconnect_0_green_leds_s1_chipselect),                   //                                           .chipselect
		.jtag_uart_avalon_jtag_slave_address              (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),        //                jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write                (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),          //                                           .write
		.jtag_uart_avalon_jtag_slave_read                 (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),           //                                           .read
		.jtag_uart_avalon_jtag_slave_readdata             (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),       //                                           .readdata
		.jtag_uart_avalon_jtag_slave_writedata            (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),      //                                           .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest          (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest),    //                                           .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect           (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),     //                                           .chipselect
		.key_1_s1_address                                 (mm_interconnect_0_key_1_s1_address),                           //                                   key_1_s1.address
		.key_1_s1_write                                   (mm_interconnect_0_key_1_s1_write),                             //                                           .write
		.key_1_s1_readdata                                (mm_interconnect_0_key_1_s1_readdata),                          //                                           .readdata
		.key_1_s1_writedata                               (mm_interconnect_0_key_1_s1_writedata),                         //                                           .writedata
		.key_1_s1_chipselect                              (mm_interconnect_0_key_1_s1_chipselect),                        //                                           .chipselect
		.key_2_s1_address                                 (mm_interconnect_0_key_2_s1_address),                           //                                   key_2_s1.address
		.key_2_s1_write                                   (mm_interconnect_0_key_2_s1_write),                             //                                           .write
		.key_2_s1_readdata                                (mm_interconnect_0_key_2_s1_readdata),                          //                                           .readdata
		.key_2_s1_writedata                               (mm_interconnect_0_key_2_s1_writedata),                         //                                           .writedata
		.key_2_s1_chipselect                              (mm_interconnect_0_key_2_s1_chipselect),                        //                                           .chipselect
		.key_3_s1_address                                 (mm_interconnect_0_key_3_s1_address),                           //                                   key_3_s1.address
		.key_3_s1_write                                   (mm_interconnect_0_key_3_s1_write),                             //                                           .write
		.key_3_s1_readdata                                (mm_interconnect_0_key_3_s1_readdata),                          //                                           .readdata
		.key_3_s1_writedata                               (mm_interconnect_0_key_3_s1_writedata),                         //                                           .writedata
		.key_3_s1_chipselect                              (mm_interconnect_0_key_3_s1_chipselect),                        //                                           .chipselect
		.nios_processor_debug_mem_slave_address           (mm_interconnect_0_nios_processor_debug_mem_slave_address),     //             nios_processor_debug_mem_slave.address
		.nios_processor_debug_mem_slave_write             (mm_interconnect_0_nios_processor_debug_mem_slave_write),       //                                           .write
		.nios_processor_debug_mem_slave_read              (mm_interconnect_0_nios_processor_debug_mem_slave_read),        //                                           .read
		.nios_processor_debug_mem_slave_readdata          (mm_interconnect_0_nios_processor_debug_mem_slave_readdata),    //                                           .readdata
		.nios_processor_debug_mem_slave_writedata         (mm_interconnect_0_nios_processor_debug_mem_slave_writedata),   //                                           .writedata
		.nios_processor_debug_mem_slave_byteenable        (mm_interconnect_0_nios_processor_debug_mem_slave_byteenable),  //                                           .byteenable
		.nios_processor_debug_mem_slave_waitrequest       (mm_interconnect_0_nios_processor_debug_mem_slave_waitrequest), //                                           .waitrequest
		.nios_processor_debug_mem_slave_debugaccess       (mm_interconnect_0_nios_processor_debug_mem_slave_debugaccess), //                                           .debugaccess
		.onchip_memory_s1_address                         (mm_interconnect_0_onchip_memory_s1_address),                   //                           onchip_memory_s1.address
		.onchip_memory_s1_write                           (mm_interconnect_0_onchip_memory_s1_write),                     //                                           .write
		.onchip_memory_s1_readdata                        (mm_interconnect_0_onchip_memory_s1_readdata),                  //                                           .readdata
		.onchip_memory_s1_writedata                       (mm_interconnect_0_onchip_memory_s1_writedata),                 //                                           .writedata
		.onchip_memory_s1_byteenable                      (mm_interconnect_0_onchip_memory_s1_byteenable),                //                                           .byteenable
		.onchip_memory_s1_chipselect                      (mm_interconnect_0_onchip_memory_s1_chipselect),                //                                           .chipselect
		.onchip_memory_s1_clken                           (mm_interconnect_0_onchip_memory_s1_clken),                     //                                           .clken
		.red_leds_s1_address                              (mm_interconnect_0_red_leds_s1_address),                        //                                red_leds_s1.address
		.red_leds_s1_write                                (mm_interconnect_0_red_leds_s1_write),                          //                                           .write
		.red_leds_s1_readdata                             (mm_interconnect_0_red_leds_s1_readdata),                       //                                           .readdata
		.red_leds_s1_writedata                            (mm_interconnect_0_red_leds_s1_writedata),                      //                                           .writedata
		.red_leds_s1_chipselect                           (mm_interconnect_0_red_leds_s1_chipselect),                     //                                           .chipselect
		.sdram_s1_address                                 (mm_interconnect_0_sdram_s1_address),                           //                                   sdram_s1.address
		.sdram_s1_write                                   (mm_interconnect_0_sdram_s1_write),                             //                                           .write
		.sdram_s1_read                                    (mm_interconnect_0_sdram_s1_read),                              //                                           .read
		.sdram_s1_readdata                                (mm_interconnect_0_sdram_s1_readdata),                          //                                           .readdata
		.sdram_s1_writedata                               (mm_interconnect_0_sdram_s1_writedata),                         //                                           .writedata
		.sdram_s1_byteenable                              (mm_interconnect_0_sdram_s1_byteenable),                        //                                           .byteenable
		.sdram_s1_readdatavalid                           (mm_interconnect_0_sdram_s1_readdatavalid),                     //                                           .readdatavalid
		.sdram_s1_waitrequest                             (mm_interconnect_0_sdram_s1_waitrequest),                       //                                           .waitrequest
		.sdram_s1_chipselect                              (mm_interconnect_0_sdram_s1_chipselect),                        //                                           .chipselect
		.sram_avalon_sram_slave_address                   (mm_interconnect_0_sram_avalon_sram_slave_address),             //                     sram_avalon_sram_slave.address
		.sram_avalon_sram_slave_write                     (mm_interconnect_0_sram_avalon_sram_slave_write),               //                                           .write
		.sram_avalon_sram_slave_read                      (mm_interconnect_0_sram_avalon_sram_slave_read),                //                                           .read
		.sram_avalon_sram_slave_readdata                  (mm_interconnect_0_sram_avalon_sram_slave_readdata),            //                                           .readdata
		.sram_avalon_sram_slave_writedata                 (mm_interconnect_0_sram_avalon_sram_slave_writedata),           //                                           .writedata
		.sram_avalon_sram_slave_byteenable                (mm_interconnect_0_sram_avalon_sram_slave_byteenable),          //                                           .byteenable
		.sram_avalon_sram_slave_readdatavalid             (mm_interconnect_0_sram_avalon_sram_slave_readdatavalid),       //                                           .readdatavalid
		.switches_s1_address                              (mm_interconnect_0_switches_s1_address),                        //                                switches_s1.address
		.switches_s1_readdata                             (mm_interconnect_0_switches_s1_readdata),                       //                                           .readdata
		.sys_clk_timer_s1_address                         (mm_interconnect_0_sys_clk_timer_s1_address),                   //                           sys_clk_timer_s1.address
		.sys_clk_timer_s1_write                           (mm_interconnect_0_sys_clk_timer_s1_write),                     //                                           .write
		.sys_clk_timer_s1_readdata                        (mm_interconnect_0_sys_clk_timer_s1_readdata),                  //                                           .readdata
		.sys_clk_timer_s1_writedata                       (mm_interconnect_0_sys_clk_timer_s1_writedata),                 //                                           .writedata
		.sys_clk_timer_s1_chipselect                      (mm_interconnect_0_sys_clk_timer_s1_chipselect),                //                                           .chipselect
		.sysid_control_slave_address                      (mm_interconnect_0_sysid_control_slave_address),                //                        sysid_control_slave.address
		.sysid_control_slave_readdata                     (mm_interconnect_0_sysid_control_slave_readdata)                //                                           .readdata
	);

	niosiiSystem_irq_mapper irq_mapper (
		.clk           (clk_clk),                        //       clk.clk
		.reset         (rst_controller_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),       // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),       // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),       // receiver2.irq
		.receiver3_irq (irq_mapper_receiver3_irq),       // receiver3.irq
		.receiver4_irq (irq_mapper_receiver4_irq),       // receiver4.irq
		.sender_irq    (nios_processor_irq_irq)          //    sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_reset_n),                           // reset_in0.reset
		.reset_in1      (nios_processor_debug_reset_request_reset), // reset_in1.reset
		.clk            (clk_clk),                                  //       clk.clk
		.reset_out      (rst_controller_reset_out_reset),           // reset_out.reset
		.reset_req      (rst_controller_reset_out_reset_req),       //          .reset_req
		.reset_req_in0  (1'b0),                                     // (terminated)
		.reset_req_in1  (1'b0),                                     // (terminated)
		.reset_in2      (1'b0),                                     // (terminated)
		.reset_req_in2  (1'b0),                                     // (terminated)
		.reset_in3      (1'b0),                                     // (terminated)
		.reset_req_in3  (1'b0),                                     // (terminated)
		.reset_in4      (1'b0),                                     // (terminated)
		.reset_req_in4  (1'b0),                                     // (terminated)
		.reset_in5      (1'b0),                                     // (terminated)
		.reset_req_in5  (1'b0),                                     // (terminated)
		.reset_in6      (1'b0),                                     // (terminated)
		.reset_req_in6  (1'b0),                                     // (terminated)
		.reset_in7      (1'b0),                                     // (terminated)
		.reset_req_in7  (1'b0),                                     // (terminated)
		.reset_in8      (1'b0),                                     // (terminated)
		.reset_req_in8  (1'b0),                                     // (terminated)
		.reset_in9      (1'b0),                                     // (terminated)
		.reset_req_in9  (1'b0),                                     // (terminated)
		.reset_in10     (1'b0),                                     // (terminated)
		.reset_req_in10 (1'b0),                                     // (terminated)
		.reset_in11     (1'b0),                                     // (terminated)
		.reset_req_in11 (1'b0),                                     // (terminated)
		.reset_in12     (1'b0),                                     // (terminated)
		.reset_req_in12 (1'b0),                                     // (terminated)
		.reset_in13     (1'b0),                                     // (terminated)
		.reset_req_in13 (1'b0),                                     // (terminated)
		.reset_in14     (1'b0),                                     // (terminated)
		.reset_req_in14 (1'b0),                                     // (terminated)
		.reset_in15     (1'b0),                                     // (terminated)
		.reset_req_in15 (1'b0)                                      // (terminated)
	);

endmodule
